<script setup>
import {
  subDays,
  addDays,
  eachDayOfInterval,
  format,
  startOfMonth,
  compareAsc,
  startOfDay,
  addMonths,
  subMonths,
  getDay,
  parseISO,
  isWithinInterval,
  isSameMonth,
} from "date-fns";

const events = ref([
  {
    id: 1,
    startDate: "2023-08-11",
    endDate: "2023-08-13",
    event: "Ujian Nasional",
  },
  {
    id: 4,
    startDate: "2023-08-02",
    endDate: "2023-08-02",
    event: "Ujian Tengah Semester",
  },
  {
    id: 5,
    startDate: "2023-08-03",
    endDate: "2023-08-03",
    event: "Ujian Tengah Semester",
  },
  {
    id: 6,
    startDate: "2023-08-10",
    endDate: "2023-08-10",
    event: "Pembayaran SPP",
  },
  {
    id: 7,
    startDate: "2023-08-20",
    endDate: "2023-08-20",
    event: "Pengambilan KRS",
  },
  {
    id: 8,
    startDate: "2023-08-25",
    endDate: "2023-08-25",
    event: "Perkuliahan",
  },
  {
    id: 9,
    startDate: "2023-08-02",
    endDate: "2023-08-05",
    event: "Ujian Tengah Semester 2",
  },
  {
    id: 10,
    startDate: "2023-08-25",
    endDate: "2023-08-27",
    event: "Ujian akhir Semester 2",
  },
]);

const currentDate = ref(startOfDay(new Date()));
const currentMonth = ref(startOfMonth(currentDate.value));
const selectedDate = ref(currentDate.value);

const days = computed(() => {
  const dayNumInWeek = getDay(currentMonth.value);

  const calendarStart = subDays(
    currentMonth.value,
    dayNumInWeek !== 0 ? dayNumInWeek - 1 : 6
  );

  return eachDayOfInterval({
    start: calendarStart,
    end: addDays(calendarStart, 41),
  }).map((date) => {
    {
      return {
        isCurrent: compareAsc(currentDate.value, date) === 0,
        isCurrentMonth: isSameMonth(date, currentMonth.value),
        isSelected: compareAsc(selectedDate.value, date) === 0,
        date: date,
        hasEvent: events.value.some((event) =>
          isWithinInterval(date, {
            start: parseISO(event.startDate),
            end: parseISO(event.endDate),
          })
        ),
      };
    }
  });
});

function getStartDate() {
  return days.value[0].date;
}

function getEndDate() {
  return days.value[41].date;
}

function toNextMonth() {
  currentMonth.value = addMonths(currentMonth.value, 1);
  selectedDate.value = currentMonth.value;
}

function toPreviousMonth() {
  currentMonth.value = subMonths(currentMonth.value, 1);
  selectedDate.value = currentMonth.value;
}

function selectDate(date) {
  selectedDate.value = date;
  if (!isSameMonth(date, currentMonth.value))
    currentMonth.value = startOfMonth(date);
}
</script>
<template>
  <div class="bg-light-50 rounded-2xl shadow-lg mt-8 p-4">
    <p class="text-lg text-dark-950 text-center mb-3">Kalender Akademik</p>
    <hr />
    <div class="flex justify-between space-x-2 py-3 items-center">
      <button
        class="rounded-lg text-gray-500 hover:bg-gray-100 hover:text-gray-900 text-lg p-2.5"
        type="button"
        @click="toPreviousMonth"
      >
        <span class="sr-only">Previous month</span>
        <svg
          xmlns="http://www.w3.org/2000/svg"
          fill="none"
          viewBox="0 0 24 24"
          stroke-width="1.5"
          stroke="currentColor"
          class="w-4 h-4"
        >
          <path
            stroke-linecap="round"
            stroke-linejoin="round"
            d="M15.75 19.5L8.25 12l7.5-7.5"
          />
        </svg>
      </button>
      <h2 class="font-semibold text-gray-800 text-base">
        {{ format(currentMonth, "MMMM yyyy") }}
      </h2>
      <button
        type="button"
        class="rounded-lg text-gray-500 hover:bg-gray-100 hover:text-gray-900 text-lg p-2.5"
        @click="toNextMonth"
      >
        <svg
          xmlns="http://www.w3.org/2000/svg"
          fill="none"
          viewBox="0 0 24 24"
          stroke-width="1.5"
          stroke="currentColor"
          class="w-4 h-4"
        >
          <path
            stroke-linecap="round"
            stroke-linejoin="round"
            d="M8.25 4.5l7.5 7.5-7.5 7.5"
          />
        </svg>
      </button>
    </div>
    <div class="mt-2 grid grid-cols-7 text-center text-sm">
      <div class="text-gray_500">Mo</div>
      <div class="text-gray_500">Tu</div>
      <div class="text-gray_500">We</div>
      <div class="text-gray_500">Th</div>
      <div class="text-gray_500">Fr</div>
      <div class="text-gray_500">Sa</div>
      <div class="text-gray_500">Su</div>
    </div>
    <div class="mt-2 grid grid-cols-7 gap-1">
      <button
        v-for="(day, index) in days"
        :key="`day-${index}`"
        type="button"
        class="mx-auto flex h-10 w-10 items-center justify-center rounded-lg"
        @click="selectDate(day.date)"
        :class="{
          'bg-secondary-500': day.isCurrent && !day.isSelected,
          'bg-primary-700': day.isSelected,
          'bg-light-100': day.hasEvent && !day.isCurrent && !day.isSelected,
        }"
      >
        <time
          :class="{
            'text-dark-300': !day.isCurrentMonth,
            'text-dark-950 ':
              day.isCurrentMonth && !day.isCurrent && !day.isSelected,
            'text-light-50': day.isCurrent || day.isSelected,
          }"
        >
          {{ format(day.date, "d") }}
        </time>
      </button>
    </div>
    <hr class="my-3" />
    <div>
      <p class="text-dark-950">
        {{ format(selectedDate, "EEEE, dd MMMM yyyy") }}
      </p>
      <ol
        class="relative mt-2"
        v-for="event in events.filter((event) =>
          isWithinInterval(selectedDate, {
            start: parseISO(event.startDate),
            end: parseISO(event.endDate),
          })
        )"
      >
        <li class="ml-3">
          <div
            class="absolute w-2 h-2 bg-primary-700 rounded-full mt-1 -left-1 border border-white"
          ></div>
          <p class="text-dark-400 text-sm">{{ event.event }}</p>
        </li>
      </ol>
    </div>
  </div>
</template>
